#include "AudioRender.h"

#include <assert.h>
#include <memory>

#include "IAudioRender.h"

static std::unique_ptr<IAudioRender> audiosRender_;
bool __stdcall Initialize(callback_t cb) {
    assert(!audiosRender_);

    auto logCallback = [cb](int32 level, const int8* log, uint32 length) {
        if (nullptr == cb) {
            cb(level, log, length);
        }
    };
    audiosRender_.reset(IAudioRender::Create(std::move(logCallback)));
    return true;
}

bool __stdcall Write(const unsigned char* data, unsigned int len) {
    assert(audiosRender_);

    std::vector<unsigned char> audio(len, 0);
    memcpy(&audio[0], data, len);
    AudioFrame frame = { audio, 0 };
    return audiosRender_->Write(frame);
}

void __stdcall Uninitialize() {
    assert(audiosRender_);
    audiosRender_.reset();
}
