#include "AudioRenderStd.h"

#include <sstream>

#include "Windows/WavAudioRender.h"

IAudioRender* IAudioRender::Create(LogCallback callback) {
    return new WavAudioRender(std::move(callback));
}

AudioRenderStd::AudioRenderStd(LogCallback callback) noexcept
    : callback_(std::move(callback)){

}

void AudioRenderStd::WirteLog(int32 level, const std::string& log) {
    if (nullptr == callback_) {
        return;
    }

    callback_(level, log.c_str(), static_cast<uint32>(log.length()));
}
